﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GpsModule {
	public class GgaData : SharedGpsData {

		/*
		GGA Global Positioning System Fix Data. Time, Position and fix related data
		for a GPS receiver
															 11
			   1         2       3 4        5 6 7  8   9  10 |  12 13 14   15
			   |         |       | |        | | |  |   |   | |   | |   |    |
		$--GGA,hhmmss.ss,llll.ll,a,yyyyy.yy,a,x,xx,x.x,x.x,M,x.x,M,x.x,xxxx*hh
		1) Time (UTC)
		2) Latitude
		3) N or S (North or South)
		4) Longitude
		5) E or W (East or West)
		6) GPS Quality Indicator,
		0 - fix not available,
		1 - GPS fix,
		2 - Differential GPS fix
		7) Number of satellites in view, 00 - 12
		8) Horizontal Dilution of precision
		9) Antenna Altitude above/below mean-sea-level (geoid)
		10) Units of antenna altitude, meters
		11) Geoidal separation, the difference between the WGS-84 earth
		ellipsoid and mean-sea-level (geoid), "-" means mean-sea-level below ellipsoid
		12) Units of geoidal separation, meters
		13) Age of differential GPS data, time in seconds since last SC104
		type 1 or 9 update, null field when DGPS is not used
		14) Differential reference station ID, 0000-1023
		15) Checksum
		 */

		int _qualityIndicator = 0;
		public int QualityIndicator {
			get { return _qualityIndicator; }
		}
		public void setQualityIndicator(int qualityIndicator) {
			_qualityIndicator = qualityIndicator; }

		int _satelitesInView = 0;
		public int SatelitesInView {
			get { return _satelitesInView; }
		}
		public void setSatelitesInView(int satelitesInView) {
			_satelitesInView = satelitesInView;
		}

		double _horizontalDilutionOfPrecision = 0;
		public double HorizontalDilutionOfPrecision {
			get { return _horizontalDilutionOfPrecision; }
		}
		public void setHorizontalDilutionOfPrecision(double horizontalDilutionOfPrecision) {
			_horizontalDilutionOfPrecision = horizontalDilutionOfPrecision;
		}

		double _antennaAltitude = 0;
		public double AntennaAltitude {
			get { return _antennaAltitude; }
		}
		public void setAntennaAltitude(double antennaAltitude) {
			_antennaAltitude = antennaAltitude;
		}

		char _unitsOfAntennaAltitude = 'M';
		public char UnitsOfAntennaAltitude {
			get { return _unitsOfAntennaAltitude; }
		}
		public void setUnitsOfAntennaAltitude(char antennaAltitude) {
			_unitsOfAntennaAltitude = antennaAltitude;
		}

		double _geoidalSeparation = 0;
		public double GeoidalSeparation {
			get { return _geoidalSeparation; }
		}
		public void setGeoidalSeparation(double geoidalSeparation) {
			_geoidalSeparation = geoidalSeparation;
		}

		char _unitsOfGeoidalSeperation = 'M';
		public char UnitsOfGeoidalSeperation {
			get { return _unitsOfGeoidalSeperation; }
		}
		public void setUnitsOfGeoidalSeperation(char unitsOfGeoidalSeperation) {
			_unitsOfGeoidalSeperation = unitsOfGeoidalSeperation;
		}

		double _ageOfDifferentialGPSData = 0;
		public double AgeOfDifferentialGPSData {
			get { return _ageOfDifferentialGPSData; }
		}
		public void setAgeOfDifferentialGPSData(double ageOfDifferentialGPSData) {
			_ageOfDifferentialGPSData = ageOfDifferentialGPSData;
		}

		int _differentialReferenceStationID = 0;
		public int DifferentialReferenceStationID {
			get { return _differentialReferenceStationID; }
		}
		public void setDifferentialReferenceStationID(int differentialReferenceStationID) {
			_differentialReferenceStationID = differentialReferenceStationID;
		}
	}
}
