﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace PlatformController {
	public partial class PidTuner : Form {

		PlatformStrategy _strategy;

		public PidTuner(ref PlatformStrategy strategy) {
			_strategy = strategy;
			_strategy.Data.setAutoAvoid(false);
			_strategy.setManualOverride(true);
			InitializeComponent();
			setPointTextBox.Text = _strategy.Data.ThrottleSetpoint.ToString();
			kpTextBox.Text = PidControl.Kp.ToString();
			kiTextBox.Text = PidControl.Ki.ToString();
			kdTextBox.Text = PidControl.Kd.ToString();
		}

		private void setPidButton_Click(object sender, EventArgs e) {
			try {
				_strategy.Data.ThrottleSetpoint = int.Parse(setPointTextBox.Text);
				PidControl.setPidCoefficients(double.Parse(kpTextBox.Text)
					, double.Parse(kiTextBox.Text), double.Parse(kdTextBox.Text));
				toolStripStatusLabel1.Text = "ok";
			} catch (Exception ex) {
				toolStripStatusLabel1.Text = "non-numeric entry";
			}
		}

		private void updateTimer_Tick(object sender, EventArgs e) {
			processVariableTextBox.Text = _strategy.Data.CountsPerSecond.ToString();
			manipulatedVariableTextBox.Text = _strategy.ManualThrottle.ToString();
			pComponentTextBox.Text = PidControl.PComponent.ToString();
			iComponentTextBox.Text = PidControl.IComponent.ToString();
			dComponentTextBox.Text = PidControl.DComponent.ToString();
		}
	}
}
