﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace RacePlotter {
    class InitializationParameters {
		
		public delegate void updateErrorEventHandler(Exception error);
		public static event updateErrorEventHandler updateErrorEvent;

		static Dictionary<string, string> _iniFileParameters;
		public static Dictionary<string, string> IniFileParameters {
			get { return InitializationParameters._iniFileParameters; }
		}

		private static string _status = "ok";
		public static string Status {
			get { return InitializationParameters._status; }
		}
        
		static InitializationParameters() {
        }

		public static void readIniParameters(string iniPath) {
			try {
				StreamReader sr = new StreamReader(iniPath + ".\\map.ini");
				string s = sr.ReadToEnd();
				_iniFileParameters = new Dictionary<string, string>();
				while (s.Contains("=")) {
					while (s.IndexOf("\r\n") < s.IndexOf("="))
						s = s.Remove(0, s.IndexOf("\r\n") + 2);
					_iniFileParameters.Add((s.Substring(0, s.IndexOf("=")).Trim())
						, (s.Substring(s.IndexOf("=") + 1, s.IndexOf("\r\n")
						- (s.IndexOf("=") + 1))).Trim());
					s = s.Remove(0, s.IndexOf("\r\n") + 2);
				}
			} catch (Exception e) {
				if (updateErrorEvent != null)
					updateErrorEvent.Invoke(e);
				_status = e.Message;
			}
		}
    }
}
