﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using UtmConvert;

namespace RacePlotter {
    public partial class PointSelector : Form {

        public delegate void pointSelectEventHandler();
        public event pointSelectEventHandler pointSelectEvent;
        public event pointSelectEventHandler pointSelectCancelEvent;
        List<UtmPoint> _points;

        public PointSelector(List<UtmPoint> pts) {
            InitializeComponent();
			_points = pts;
			foreach (UtmPoint p in _points)
            waypointListBox.Items.Add("zone:" + p.Zone + ", x:" + p.Point.X
                + ", y:" + p.Point.Y + ", note:" + p.Note + ", handle:" + p.Handle);
            waypointListBox.SelectedIndex = 0;
        }

        private void selectButton_Click(object sender, EventArgs e) {
            selectPoint();
        }

        public UtmPoint getSelectedPoint() {
			return _points[waypointListBox.SelectedIndex];
        }

		//public int getSelectedPointIndex() {
		//    return waypointListBox.SelectedIndex;
		//}

        private void canceBlutton_Click(object sender, EventArgs e) {
            if (pointSelectCancelEvent != null)
                pointSelectCancelEvent.Invoke();
            this.Close();
        }

        private void waypointListBox_DoubleClick(object sender, EventArgs e) {
            selectPoint();
        }

        private void selectPoint() {
            if (pointSelectEvent != null)
                pointSelectEvent.Invoke();
            this.Close();
        }

    }
}
