﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Xml;

namespace system_controller {
	public class Logger {
		protected string _filePath;
		protected string _extension;
		StreamWriter _sWrite;
	
		public Logger() {
		}

		~Logger() {
			//_sWrite.Flush();
			//_sWrite.Close();
		}

		public void openFile() {
			string dt = DateTime.Now.ToString().Replace('/', '-');
			dt = dt.Replace(':', '-');
			_sWrite = new StreamWriter(_filePath
				+ dt + _extension);
		}

		public void write(string data) {
			_sWrite.Write(data);
			_sWrite.Flush();
		}

	}

	public class DataLogger : Logger {
		public DataLogger() {
			_filePath = InitializationParameters
				.IniFileParameters["pathDataLog"];
			_extension = ".data";
			if (!Directory.Exists(_filePath))
				Directory.CreateDirectory(_filePath);
		}
	}

	public class ErrorLogger : Logger {
		public ErrorLogger() {
			_filePath = InitializationParameters
				.IniFileParameters["pathErrorLog"];
			_extension = ".error";
			if (!Directory.Exists(_filePath))
				Directory.CreateDirectory(_filePath);
		}
	}

	public class EventLogger : Logger {
		public EventLogger() {
			_filePath = InitializationParameters
				.IniFileParameters["pathEventLog"];
			_extension = ".event";
			if (!Directory.Exists(_filePath))
				Directory.CreateDirectory(_filePath);
		}
	}
}
