﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using UtmConvert;

namespace system_controller {
    public partial class PointPickerForm : Form {

        public delegate void waypointSelectEventHandler();
        public event waypointSelectEventHandler waypointSelectEvent;
        public event waypointSelectEventHandler waypointSelectCancelEvent;
        List<UtmPoint> _pointSet;

        public PointPickerForm(List<UtmPointSet> pts) {
            InitializeComponent();
            _pointSet = new List<UtmPoint>();
            _pointSet = pts[0].Points;
            foreach (UtmPoint p in _pointSet)
            waypointListBox.Items.Add("zone:" + p.Zone + ", x:" + p.Point.X
                + ", y:" + p.Point.Y + ", note:" + p.Note + ", handle:" + p.Handle);
            waypointListBox.SelectedIndex = 0;
        }

        private void selectButton_Click(object sender, EventArgs e) {
            selectWaypoint();
        }

        public UtmPoint getSelectedPoint() {
            return _pointSet[waypointListBox.SelectedIndex];
        }

        private void canceBlutton_Click(object sender, EventArgs e) {
            if (waypointSelectCancelEvent != null)
                waypointSelectCancelEvent.Invoke();
            this.Close();
        }

        private void waypointListBox_DoubleClick(object sender, EventArgs e) {
            selectWaypoint();
        }

        private void selectWaypoint() {
            if (waypointSelectEvent != null)
                waypointSelectEvent.Invoke();
            this.Close();
        }

    }
}
