﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace system_controller {
	public partial class RacePlotterForm : Form {
		bool _selectFiducials = false;
		RacePlotterStrategy _strategy;

		public RacePlotterForm() {
			InitializeComponent();
			_strategy = new RacePlotterStrategy();
		}

		private void fiducialsToolStripMenuItem_Click(object sender, EventArgs e) {
			_selectFiducials = true;
		}

		private void raceMapPictureBox_Click(object sender, EventArgs e) {
			if (_selectFiducials == true) {
                Bitmap b = new Bitmap(mapPictureBox.Image);
				_strategy.drawClickedWaypoint(ref b, (int)(e.X * ((double)(b.Width)
                    / (double)(mapPictureBox.Width)))
                    , (int)(e.Y * ((double)(b.Height) / (double)(raceMapPictureBox.Height))));
				raceMapPictureBox.Image = b;
				raceMapPictureBox.Invalidate();
                _pointPicker = new PointPickerForm(_data.Parser.UtmPointSetList);
				_pointPicker.waypointSelectEvent += onWaypointSelect;
				_pointPicker.waypointSelectCancelEvent += onWaypointSelectCancel;
				_pointPicker.Show();
            }
		}
	}
}
