﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UtmConvert;
using System.Drawing;

namespace system_controller {
	class RacePlotterStrategy {

		List<UtmPoint> _fiducials;
		List<UtmPoint> _waypoints;

		System.Drawing.Point _click1, _click2;
		UtmPoint _utmPoint1, _utmPoint2;

		float _scaleDeltaX;
		public float ScaleDeltaX {
			get { return _scaleDeltaX; }
		}

		float _scaleDeltaY;
		public float ScaleDeltaY {
			get { return _scaleDeltaY; }
		}

		float _scaleX;
		public float ScaleX {
			get { return _scaleX; }
		}

		float _scaleY;
		public float ScaleY {
			get { return _scaleY; }
		}

		public RacePlotterStrategy() {
			_click1 = new System.Drawing.Point();
			_click2 = new System.Drawing.Point();
			_utmPoint1 = new UtmPoint();
			_utmPoint2 = new UtmPoint();
		}

		public void drawRacePath(ref Bitmap map) {
			float deltaClickX = (float)_click2.X - (float)_click1.X;
			float deltaClickY = (float)_click2.Y - (float)_click1.Y;
			float deltaUtmX = (float)(_utmPoint2.Point.X - _utmPoint1.Point.X);
			float deltaUtmY = (float)(_utmPoint2.Point.Y - _utmPoint1.Point.Y);
			_scaleDeltaX = deltaClickX / deltaUtmX;
			_scaleDeltaY = deltaClickY / deltaUtmY;
			_scaleX = (float)_click1.X / (float)_utmPoint1.Point.X;
			_scaleY = (float)_click1.Y / (float)_utmPoint1.Point.Y;
			Graphics g = Graphics.FromImage(map);
			Pen pen = new Pen(Color.Red, 8);
			SolidBrush brush = new SolidBrush(Color.Orange);
			SolidBrush gBrush = new SolidBrush(Color.Gray);
			float nextX = 0, nextY = 0;
			for (int i = 0; i < _parser.UtmPointSetList[0].Points.Count; ++i) {
				float deltaX = (float)(_parser.UtmPointSetList[0].Points[i].Point.X)
					- (float)(_utmPoint1.Point.X);
				float deltaY = (float)(_parser.UtmPointSetList[0].Points[i].Point.Y)
					- (float)(_utmPoint1.Point.Y);
				float x1 = (float)(_parser.UtmPointSetList[0].Points[i].Point.X);
				float y1 = (float)(_parser.UtmPointSetList[0].Points[i].Point.Y);
				if (_parser.UtmPointSetList[0].Points[i].Note == "dummy")
					g.FillEllipse(gBrush, x1 * _scaleX + deltaX * _scaleDeltaX
						- 16, y1 * _scaleY + deltaY * _scaleDeltaY - 16, 32, 32);
				else
					g.FillEllipse(brush, x1 * _scaleX + deltaX * _scaleDeltaX
						- 16, y1 * _scaleY + deltaY * _scaleDeltaY - 16, 32, 32);
				g.DrawLine(pen, x1 * _scaleX + nextX, y1 * _scaleY + nextY
					, x1 * _scaleX + deltaX * _scaleDeltaX
					, y1 * _scaleY + deltaY * _scaleDeltaY);
				nextX = _scaleX + deltaX * _scaleDeltaX;
				nextY = _scaleY + deltaY * _scaleDeltaY;
			}
		}

		public void drawClickedWaypoint(ref Bitmap map, int x, int y) {
			if (_click1.IsEmpty) { _click1.X = x; _click1.Y = y; } else { _click2.X = x; _click2.Y = y; }
			Graphics g = Graphics.FromImage(map);
			SolidBrush brush = new SolidBrush(Color.Green);
			g.FillEllipse(brush, x - 16, y - 16, 32, 32);
		}

	}
}
