﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UtmConvert;

namespace system_controller {
	class VectorCalculator {

		UtmPoint _startPoint;

		public VectorCalculator(UtmPoint startPoint) {
			_startPoint = new UtmPoint();
			_startPoint = startPoint;
		}

		public UtmPoint getPointFromVector(UtmPoint pt, double distance, double heading) {
			//take the distance and heading and createa a new point relative to 
			//the point passed in, then pass the new point back out.
			//this is essentially polar to rectangular conversion here
			//distance is in meters, and heading is in offset degrees.
			//distance is hypotenuse
			//x easting: x / distance = cos(heading)
			//y northing: y / distance = sin(heading)
			double x = Math.Cos(ConvertDegRad.getRadians(heading)) * distance;
			double y = Math.Sin(ConvertDegRad.getRadians(heading)) * distance;
			pt.Point.X += x;
			pt.Point.Y += y;
			pt.Note = "Generated by vector calculator.";
			pt.Handle = DateTime.Now.ToString();
			return pt;
		}

		//uses vector addition to add up all the vectors to produce the 
		//current location, should produce the same output as the above
		//function actually
		public UtmPoint getVectorAdditionPoint(List<UtmPoint> pts) {
			double x = _startPoint.Point.X;
			double y = _startPoint.Point.Y;
			foreach (UtmPoint p in pts) {
				x += p.Point.X;
				y += p.Point.Y;
			}
			UtmPoint pt = new UtmPoint(new Point(x, y)
				, _startPoint.Zone
				, "Generated by vector calculator."
				, DateTime.Now.ToString());
			return pt;

		}
	}
}
