﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using UtmConvert;

namespace system_controller {
    public partial class WaypointInserter : Form {
        public delegate void waypointInsertEventHandler();
        public event waypointInsertEventHandler waypointInsertEvent;

        UtmPoint _pt;
        int _pntCnt = 0;

        public WaypointInserter(UtmPoint pt, int ptCnt) {
            InitializeComponent();
            _pt = new UtmPoint();
            _pt = pt;
            _pntCnt = ptCnt;
            utmPointPropertyGrid.SelectedObject = _pt;
            for (int i = 1; i < _pntCnt; ++i)
                pointIndexListBox.Items.Add(i);
            pointIndexListBox.SelectedIndex = 0;
            this.Text = "Insert Waypoint: " 
                + Math.Round(_pt.Point.X, 2).ToString() + ", "
                + Math.Round(_pt.Point.Y, 2).ToString();
        }

        private void insertButton_Click(object sender, EventArgs e) {
            if (waypointInsertEvent != null)
                waypointInsertEvent.Invoke();
            this.Close();
        }

        private void canceBlutton_Click(object sender, EventArgs e) {
            this.Close();
        }

        public UtmPoint getInsertedWaypoint() {
            return _pt;
        }

        public int getInsertedWaypointIndex() {
            return int.Parse(pointIndexListBox.SelectedItem.ToString());
        }
    }
}
